# coding: utf-8

# GTO-MO-1-1 - Removed partial_header
# flake8: noqa

from datetime import date, datetime
import decimal
import functools
import io
import re
import typing
import typing_extensions
import uuid

import frozendict

from chkp_harmony_endpoint_management_sdk.generated.cloud import schemas


class ComputerColumnNames(
    schemas.EnumBase,
    schemas.StrSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Defines a union of all known fields that can be used to filter computers
    """


    class MetaOapg:
        enum_value_to_name = {
            "emonJsonDataColumns": "EMON_JSON_DATA_COLUMNS",
            "computerId": "COMPUTER_ID",
            "computerName": "COMPUTER_NAME",
            "computerCapabilities": "COMPUTER_CAPABILITIES",
            "computerInactiveCapabilities": "COMPUTER_INACTIVE_CAPABILITIES",
            "computerDeploymentStatus": "COMPUTER_DEPLOYMENT_STATUS",
            "computerIP": "COMPUTER_IP",
            "computerClientVersion": "COMPUTER_CLIENT_VERSION",
            "osName": "OS_NAME",
            "osVersion": "OS_VERSION",
            "daInstalled": "DA_INSTALLED",
            "computerDeployTime": "COMPUTER_DEPLOY_TIME",
            "computerDeployTimeFrom": "COMPUTER_DEPLOY_TIME_FROM",
            "computerDeployTimeTo": "COMPUTER_DEPLOY_TIME_TO",
            "computerLastErrorCode": "COMPUTER_LAST_ERROR_CODE",
            "computerLastErrorDescription": "COMPUTER_LAST_ERROR_DESCRIPTION",
            "computerLastConnection": "COMPUTER_LAST_CONNECTION",
            "computerLastConnectionFrom": "COMPUTER_LAST_CONNECTION_FROM",
            "computerLastConnectionTo": "COMPUTER_LAST_CONNECTION_TO",
            "computerSyncedonTo": "COMPUTER_SYNCEDON_TO",
            "computerSyncedon": "COMPUTER_SYNCEDON",
            "computerSyncedonFrom": "COMPUTER_SYNCEDON_FROM",
            "syncedOn": "SYNCED_ON",
            "computerLastLoggedInUser": "COMPUTER_LAST_LOGGED_IN_USER",
            "computerLastLoggedInPrebootUser": "COMPUTER_LAST_LOGGED_IN_PREBOOT_USER",
            "computerFdeStatus": "COMPUTER_FDE_STATUS",
            "computerFdeVersion": "COMPUTER_FDE_VERSION",
            "computerFdeLastRecoveryDate": "COMPUTER_FDE_LAST_RECOVERY_DATE",
            "computerFdeLastRecoveryDateFrom": "COMPUTER_FDE_LAST_RECOVERY_DATE_FROM",
            "computerFdeLastRecoveryDateTo": "COMPUTER_FDE_LAST_RECOVERY_DATE_TO",
            "computerFdeWilWolStatus": "COMPUTER_FDE_WIL_WOL_STATUS",
            "computerFdeTpmId": "COMPUTER_FDE_TPM_ID",
            "computerFdeTpmStatus": "COMPUTER_FDE_TPM_STATUS",
            "computerFdeTpmVersion": "COMPUTER_FDE_TPM_VERSION",
            "computerFdeWilWolStatusUpdatedOn": "COMPUTER_FDE_WIL_WOL_STATUS_UPDATED_ON",
            "computerFdeWilWolStatusUpdatedOnFrom": "COMPUTER_FDE_WIL_WOL_STATUS_UPDATED_ON_FROM",
            "computerFdeWilWolStatusUpdatedOnTo": "COMPUTER_FDE_WIL_WOL_STATUS_UPDATED_ON_TO",
            "computerFdeProgress": "COMPUTER_FDE_PROGRESS",
            "computerFdeProgressFrom": "COMPUTER_FDE_PROGRESS_FROM",
            "computerFdeProgressTo": "COMPUTER_FDE_PROGRESS_TO",
            "computerType": "COMPUTER_TYPE",
            "endpointType": "ENDPOINT_TYPE",
            "amUpdatedOn": "AM_UPDATED_ON",
            "amUpdatedOnFrom": "AM_UPDATED_ON_FROM",
            "amUpdatedOnTo": "AM_UPDATED_ON_TO",
            "amStatus": "AM_STATUS",
            "isolated": "ISOLATED",
            "isDeleted": "IS_DELETED",
            "complianceStatus": "COMPLIANCE_STATUS",
            "amUpdatedIntervalStatus": "AM_UPDATED_INTERVAL_STATUS",
            "isInDomain": "IS_IN_DOMAIN",
            "domainName": "DOMAIN_NAME",
            "o_x": "O_X",
            "devices_emon_status_data_selector": "DEVICES_EMON_STATUS_DATA_SELECTOR",
            "deleted_devices_emon_status_data_selector": "DELETED_DEVICES_EMON_STATUS_DATA_SELECTOR",
            "computerAmDatVersion": "COMPUTER_AM_DAT_VERSION",
            "computerAmDatDate": "COMPUTER_AM_DAT_DATE",
            "computerAmDatDateFrom": "COMPUTER_AM_DAT_DATE_FROM",
            "computerAmDatDateTo": "COMPUTER_AM_DAT_DATE_TO",
            "computerAmLicExpirationDate": "COMPUTER_AM_LIC_EXPIRATION_DATE",
            "computerAmProviderBrandReport": "COMPUTER_AM_PROVIDER_BRAND_REPORT",
            "computerAmLicExpirationDateFrom": "COMPUTER_AM_LIC_EXPIRATION_DATE_FROM",
            "computerAmLicExpirationDateTo": "COMPUTER_AM_LIC_EXPIRATION_DATE_TO",
            "computerAmTotalInfected": "COMPUTER_AM_TOTAL_INFECTED",
            "computerAmTotalInfectedFrom": "COMPUTER_AM_TOTAL_INFECTED_FROM",
            "computerAmTotalInfectedTo": "COMPUTER_AM_TOTAL_INFECTED_TO",
            "computerAmInfections": "COMPUTER_AM_INFECTIONS",
            "computerSdPackageName": "COMPUTER_SD_PACKAGE_NAME",
            "computerSdPolicyName": "COMPUTER_SD_POLICY_NAME",
            "computerSdPolicyVersion": "COMPUTER_SD_POLICY_VERSION",
            "computerAbState": "COMPUTER_AB_STATE",
            "computerAbStatusBotNames": "COMPUTER_AB_STATUS_BOT_NAMES",
            "computerAmScannedon": "COMPUTER_AM_SCANNEDON",
            "computerAmScannedonFrom": "COMPUTER_AM_SCANNEDON_FROM",
            "computerAmScannedonTo": "COMPUTER_AM_SCANNEDON_TO",
            "computerAmTotalQuarantined": "COMPUTER_AM_TOTAL_QUARANTINED",
            "computerAmTotalQuarantinedFrom": "COMPUTER_AM_TOTAL_QUARANTINED_FROM",
            "computerAmTotalQuarantinedTo": "COMPUTER_AM_TOTAL_QUARANTINED_TO",
            "computerLastContactedPolicyServerIp": "COMPUTER_LAST_CONTACTED_POLICY_SERVER_IP",
            "computerLastContactedPolicyServerName": "COMPUTER_LAST_CONTACTED_POLICY_SERVER_NAME",
            "computerSdPackageVersion": "COMPUTER_SD_PACKAGE_VERSION",
            "computerComplianceViolationIds": "COMPUTER_COMPLIANCE_VIOLATION_IDS",
            "computerSmartCardStatus": "COMPUTER_SMART_CARD_STATUS",
            "fdeRemoteUnlockOperation": "FDE_REMOTE_UNLOCK_OPERATION",
            "fdeRemoteUnlockStatus": "FDE_REMOTE_UNLOCK_STATUS",
            "computerCanonicalName": "COMPUTER_CANONICAL_NAME",
            "stoppedBlades": "STOPPED_BLADES",
            "enforcedModifiedOn": "ENFORCED_MODIFIED_ON",
            "enforcedPolicyMalware20": "ENFORCED_POLICY_MALWARE20",
            "enforcedPolicyTe130": "ENFORCED_POLICY_TE130",
            "enforcedPolicyEfr120": "ENFORCED_POLICY_EFR120",
            "enforcedPolicyAntibot100": "ENFORCED_POLICY_ANTIBOT100",
            "enforcedPolicyMe30": "ENFORCED_POLICY_ME30",
            "enforcedPolicyFdeDevice35": "ENFORCED_POLICY_FDE_DEVICE35",
            "enforcedPolicyFdeUser36": "ENFORCED_POLICY_FDE_USER36",
            "enforcedPolicyFw10": "ENFORCED_POLICY_FW10",
            "enforcedPolicyCompliance60": "ENFORCED_POLICY_COMPLIANCE60",
            "enforcedPolicyApplicationControl22": "ENFORCED_POLICY_APPLICATION_CONTROL22",
            "enforcedPolicySaAccessZones11": "ENFORCED_POLICY_SA_ACCESS_ZONES11",
            "enforcedPolicyCommonClientSettings51": "ENFORCED_POLICY_COMMON_CLIENT_SETTINGS51",
            "enforcedPolicyDocSecPolicy91": "ENFORCED_POLICY_DOC_SEC_POLICY91",
            "enforcedVersionPolicyMalware20": "ENFORCED_VERSION_POLICY_MALWARE20",
            "enforcedVersionPolicyTe130": "ENFORCED_VERSION_POLICY_TE130",
            "enforcedVersionPolicyEfr120": "ENFORCED_VERSION_POLICY_EFR120",
            "enforcedVersionPolicyAntibot100": "ENFORCED_VERSION_POLICY_ANTIBOT100",
            "enforcedVersionPolicyMe30": "ENFORCED_VERSION_POLICY_ME30",
            "enforcedVersionPolicyFdeDevice35": "ENFORCED_VERSION_POLICY_FDE_DEVICE35",
            "enforcedVersionPolicyFdeUser36": "ENFORCED_VERSION_POLICY_FDE_USER36",
            "enforcedVersionPolicyFw10": "ENFORCED_VERSION_POLICY_FW10",
            "enforcedVersionPolicyCompliance60": "ENFORCED_VERSION_POLICY_COMPLIANCE60",
            "enforcedVersionPolicyApplicationControl22": "ENFORCED_VERSION_POLICY_APPLICATION_CONTROL22",
            "enforcedVersionPolicySaAccessZones11": "ENFORCED_VERSION_POLICY_SA_ACCESS_ZONES11",
            "enforcedVersionPolicyCommonClientSettings51": "ENFORCED_VERSION_POLICY_COMMON_CLIENT_SETTINGS51",
            "enforcedVersionPolicyDocSecPolicy91": "ENFORCED_VERSION_POLICY_DOC_SEC_POLICY91",
            "enforcedNamePolicyMalware20": "ENFORCED_NAME_POLICY_MALWARE20",
            "enforcedNamePolicyTe130": "ENFORCED_NAME_POLICY_TE130",
            "enforcedNamePolicyEfr120": "ENFORCED_NAME_POLICY_EFR120",
            "enforcedNamePolicyAntibot100": "ENFORCED_NAME_POLICY_ANTIBOT100",
            "enforcedNamePolicyMe30": "ENFORCED_NAME_POLICY_ME30",
            "enforcedNamePolicyFdeDevice35": "ENFORCED_NAME_POLICY_FDE_DEVICE35",
            "enforcedNamePolicyFdeUser36": "ENFORCED_NAME_POLICY_FDE_USER36",
            "enforcedNamePolicyFw10": "ENFORCED_NAME_POLICY_FW10",
            "enforcedNamePolicyCompliance60": "ENFORCED_NAME_POLICY_COMPLIANCE60",
            "enforcedNamePolicyApplicationControl22": "ENFORCED_NAME_POLICY_APPLICATION_CONTROL22",
            "enforcedNamePolicySaAccessZones11": "ENFORCED_NAME_POLICY_SA_ACCESS_ZONES11",
            "enforcedNamePolicyCommonClientSettings51": "ENFORCED_NAME_POLICY_COMMON_CLIENT_SETTINGS51",
            "enforcedNamePolicyDocSecPolicy91": "ENFORCED_NAME_POLICY_DOC_SEC_POLICY91",
            "deployedModifiedOn": "DEPLOYED_MODIFIED_ON",
            "deployedPolicyMalware20": "DEPLOYED_POLICY_MALWARE20",
            "deployedPolicyTe130": "DEPLOYED_POLICY_TE130",
            "deployedPolicyEfr120": "DEPLOYED_POLICY_EFR120",
            "deployedPolicyAntibot100": "DEPLOYED_POLICY_ANTIBOT100",
            "deployedPolicyMe30": "DEPLOYED_POLICY_ME30",
            "deployedPolicyFdeDevice35": "DEPLOYED_POLICY_FDE_DEVICE35",
            "deployedPolicyFdeUser36": "DEPLOYED_POLICY_FDE_USER36",
            "deployedPolicyFw10": "DEPLOYED_POLICY_FW10",
            "deployedPolicyCompliance60": "DEPLOYED_POLICY_COMPLIANCE60",
            "deployedPolicyApplicationControl22": "DEPLOYED_POLICY_APPLICATION_CONTROL22",
            "deployedPolicySaAccessZones11": "DEPLOYED_POLICY_SA_ACCESS_ZONES11",
            "deployedPolicyCommonClientSettings51": "DEPLOYED_POLICY_COMMON_CLIENT_SETTINGS51",
            "deployedPolicyDocSecPolicy91": "DEPLOYED_POLICY_DOC_SEC_POLICY91",
            "deployedVersionPolicyMalware20": "DEPLOYED_VERSION_POLICY_MALWARE20",
            "deployedVersionPolicyTe130": "DEPLOYED_VERSION_POLICY_TE130",
            "deployedVersionPolicyEfr120": "DEPLOYED_VERSION_POLICY_EFR120",
            "deployedVersionPolicyAntibot100": "DEPLOYED_VERSION_POLICY_ANTIBOT100",
            "deployedVersionPolicyMe30": "DEPLOYED_VERSION_POLICY_ME30",
            "deployedVersionPolicyFdeDevice35": "DEPLOYED_VERSION_POLICY_FDE_DEVICE35",
            "deployedVersionPolicyFdeUser36": "DEPLOYED_VERSION_POLICY_FDE_USER36",
            "deployedVersionPolicyFw10": "DEPLOYED_VERSION_POLICY_FW10",
            "deployedVersionPolicyCompliance60": "DEPLOYED_VERSION_POLICY_COMPLIANCE60",
            "deployedVersionPolicyApplicationControl22": "DEPLOYED_VERSION_POLICY_APPLICATION_CONTROL22",
            "deployedVersionPolicySaAccessZones11": "DEPLOYED_VERSION_POLICY_SA_ACCESS_ZONES11",
            "deployedVersionPolicyCommonClientSettings51": "DEPLOYED_VERSION_POLICY_COMMON_CLIENT_SETTINGS51",
            "deployedVersionPolicyDocSecPolicy91": "DEPLOYED_VERSION_POLICY_DOC_SEC_POLICY91",
            "deployedNamePolicyMalware20": "DEPLOYED_NAME_POLICY_MALWARE20",
            "deployedNamePolicyTe130": "DEPLOYED_NAME_POLICY_TE130",
            "deployedNamePolicyEfr120": "DEPLOYED_NAME_POLICY_EFR120",
            "deployedNamePolicyAntibot100": "DEPLOYED_NAME_POLICY_ANTIBOT100",
            "deployedNamePolicyMe30": "DEPLOYED_NAME_POLICY_ME30",
            "deployedNamePolicyFdeDevice35": "DEPLOYED_NAME_POLICY_FDE_DEVICE35",
            "deployedNamePolicyFdeUser36": "DEPLOYED_NAME_POLICY_FDE_USER36",
            "deployedNamePolicyFw10": "DEPLOYED_NAME_POLICY_FW10",
            "deployedNamePolicyCompliance60": "DEPLOYED_NAME_POLICY_COMPLIANCE60",
            "deployedNamePolicyApplicationControl22": "DEPLOYED_NAME_POLICY_APPLICATION_CONTROL22",
            "deployedNamePolicySaAccessZones11": "DEPLOYED_NAME_POLICY_SA_ACCESS_ZONES11",
            "deployedNamePolicyCommonClientSettings51": "DEPLOYED_NAME_POLICY_COMMON_CLIENT_SETTINGS51",
            "deployedNamePolicyDocSecPolicy91": "DEPLOYED_NAME_POLICY_DOC_SEC_POLICY91",
            "computerCpuLoadCategory": "COMPUTER_CPU_LOAD_CATEGORY",
            "computerTotalCpuLoadCategory": "COMPUTER_TOTAL_CPU_LOAD_CATEGORY",
            "computerCpuRank": "COMPUTER_CPU_RANK",
            "computerTotalCpuRank": "COMPUTER_TOTAL_CPU_RANK",
            "deviceComment": "DEVICE_COMMENT",
            "computerGroups": "COMPUTER_GROUPS",
            "computerOrUsers": "COMPUTER_OR_USERS",
            "filterAndThoseComputers": "FILTER_AND_THOSE_COMPUTERS",
            "filterAndThoseComputersOrUsers": "FILTER_AND_THOSE_COMPUTERS_OR_USERS",
            "filterComplianceStatus": "FILTER_COMPLIANCE_STATUS",
            "computerFreeSearch": "COMPUTER_FREE_SEARCH",
            "computerEnforcedInstalledPolicyName": "COMPUTER_ENFORCED_INSTALLED_POLICY_NAME",
            "computerEnforcedInstalledPolicyVersion": "COMPUTER_ENFORCED_INSTALLED_POLICY_VERSION",
            "computerStoppedBlades": "COMPUTER_STOPPED_BLADES",
            "Is_Device_In_Group": "IS_DEVICE_IN_GROUP",
            "global": "GLOBAL",
            "permission": "PERMISSION",
        }
    
    @schemas.classproperty
    def EMON_JSON_DATA_COLUMNS(cls):
        return cls("emonJsonDataColumns")
    
    @schemas.classproperty
    def COMPUTER_ID(cls):
        return cls("computerId")
    
    @schemas.classproperty
    def COMPUTER_NAME(cls):
        return cls("computerName")
    
    @schemas.classproperty
    def COMPUTER_CAPABILITIES(cls):
        return cls("computerCapabilities")
    
    @schemas.classproperty
    def COMPUTER_INACTIVE_CAPABILITIES(cls):
        return cls("computerInactiveCapabilities")
    
    @schemas.classproperty
    def COMPUTER_DEPLOYMENT_STATUS(cls):
        return cls("computerDeploymentStatus")
    
    @schemas.classproperty
    def COMPUTER_IP(cls):
        return cls("computerIP")
    
    @schemas.classproperty
    def COMPUTER_CLIENT_VERSION(cls):
        return cls("computerClientVersion")
    
    @schemas.classproperty
    def OS_NAME(cls):
        return cls("osName")
    
    @schemas.classproperty
    def OS_VERSION(cls):
        return cls("osVersion")
    
    @schemas.classproperty
    def DA_INSTALLED(cls):
        return cls("daInstalled")
    
    @schemas.classproperty
    def COMPUTER_DEPLOY_TIME(cls):
        return cls("computerDeployTime")
    
    @schemas.classproperty
    def COMPUTER_DEPLOY_TIME_FROM(cls):
        return cls("computerDeployTimeFrom")
    
    @schemas.classproperty
    def COMPUTER_DEPLOY_TIME_TO(cls):
        return cls("computerDeployTimeTo")
    
    @schemas.classproperty
    def COMPUTER_LAST_ERROR_CODE(cls):
        return cls("computerLastErrorCode")
    
    @schemas.classproperty
    def COMPUTER_LAST_ERROR_DESCRIPTION(cls):
        return cls("computerLastErrorDescription")
    
    @schemas.classproperty
    def COMPUTER_LAST_CONNECTION(cls):
        return cls("computerLastConnection")
    
    @schemas.classproperty
    def COMPUTER_LAST_CONNECTION_FROM(cls):
        return cls("computerLastConnectionFrom")
    
    @schemas.classproperty
    def COMPUTER_LAST_CONNECTION_TO(cls):
        return cls("computerLastConnectionTo")
    
    @schemas.classproperty
    def COMPUTER_SYNCEDON_TO(cls):
        return cls("computerSyncedonTo")
    
    @schemas.classproperty
    def COMPUTER_SYNCEDON(cls):
        return cls("computerSyncedon")
    
    @schemas.classproperty
    def COMPUTER_SYNCEDON_FROM(cls):
        return cls("computerSyncedonFrom")
    
    @schemas.classproperty
    def SYNCED_ON(cls):
        return cls("syncedOn")
    
    @schemas.classproperty
    def COMPUTER_LAST_LOGGED_IN_USER(cls):
        return cls("computerLastLoggedInUser")
    
    @schemas.classproperty
    def COMPUTER_LAST_LOGGED_IN_PREBOOT_USER(cls):
        return cls("computerLastLoggedInPrebootUser")
    
    @schemas.classproperty
    def COMPUTER_FDE_STATUS(cls):
        return cls("computerFdeStatus")
    
    @schemas.classproperty
    def COMPUTER_FDE_VERSION(cls):
        return cls("computerFdeVersion")
    
    @schemas.classproperty
    def COMPUTER_FDE_LAST_RECOVERY_DATE(cls):
        return cls("computerFdeLastRecoveryDate")
    
    @schemas.classproperty
    def COMPUTER_FDE_LAST_RECOVERY_DATE_FROM(cls):
        return cls("computerFdeLastRecoveryDateFrom")
    
    @schemas.classproperty
    def COMPUTER_FDE_LAST_RECOVERY_DATE_TO(cls):
        return cls("computerFdeLastRecoveryDateTo")
    
    @schemas.classproperty
    def COMPUTER_FDE_WIL_WOL_STATUS(cls):
        return cls("computerFdeWilWolStatus")
    
    @schemas.classproperty
    def COMPUTER_FDE_TPM_ID(cls):
        return cls("computerFdeTpmId")
    
    @schemas.classproperty
    def COMPUTER_FDE_TPM_STATUS(cls):
        return cls("computerFdeTpmStatus")
    
    @schemas.classproperty
    def COMPUTER_FDE_TPM_VERSION(cls):
        return cls("computerFdeTpmVersion")
    
    @schemas.classproperty
    def COMPUTER_FDE_WIL_WOL_STATUS_UPDATED_ON(cls):
        return cls("computerFdeWilWolStatusUpdatedOn")
    
    @schemas.classproperty
    def COMPUTER_FDE_WIL_WOL_STATUS_UPDATED_ON_FROM(cls):
        return cls("computerFdeWilWolStatusUpdatedOnFrom")
    
    @schemas.classproperty
    def COMPUTER_FDE_WIL_WOL_STATUS_UPDATED_ON_TO(cls):
        return cls("computerFdeWilWolStatusUpdatedOnTo")
    
    @schemas.classproperty
    def COMPUTER_FDE_PROGRESS(cls):
        return cls("computerFdeProgress")
    
    @schemas.classproperty
    def COMPUTER_FDE_PROGRESS_FROM(cls):
        return cls("computerFdeProgressFrom")
    
    @schemas.classproperty
    def COMPUTER_FDE_PROGRESS_TO(cls):
        return cls("computerFdeProgressTo")
    
    @schemas.classproperty
    def COMPUTER_TYPE(cls):
        return cls("computerType")
    
    @schemas.classproperty
    def ENDPOINT_TYPE(cls):
        return cls("endpointType")
    
    @schemas.classproperty
    def AM_UPDATED_ON(cls):
        return cls("amUpdatedOn")
    
    @schemas.classproperty
    def AM_UPDATED_ON_FROM(cls):
        return cls("amUpdatedOnFrom")
    
    @schemas.classproperty
    def AM_UPDATED_ON_TO(cls):
        return cls("amUpdatedOnTo")
    
    @schemas.classproperty
    def AM_STATUS(cls):
        return cls("amStatus")
    
    @schemas.classproperty
    def ISOLATED(cls):
        return cls("isolated")
    
    @schemas.classproperty
    def IS_DELETED(cls):
        return cls("isDeleted")
    
    @schemas.classproperty
    def COMPLIANCE_STATUS(cls):
        return cls("complianceStatus")
    
    @schemas.classproperty
    def AM_UPDATED_INTERVAL_STATUS(cls):
        return cls("amUpdatedIntervalStatus")
    
    @schemas.classproperty
    def IS_IN_DOMAIN(cls):
        return cls("isInDomain")
    
    @schemas.classproperty
    def DOMAIN_NAME(cls):
        return cls("domainName")
    
    @schemas.classproperty
    def O_X(cls):
        return cls("o_x")
    
    @schemas.classproperty
    def DEVICES_EMON_STATUS_DATA_SELECTOR(cls):
        return cls("devices_emon_status_data_selector")
    
    @schemas.classproperty
    def DELETED_DEVICES_EMON_STATUS_DATA_SELECTOR(cls):
        return cls("deleted_devices_emon_status_data_selector")
    
    @schemas.classproperty
    def COMPUTER_AM_DAT_VERSION(cls):
        return cls("computerAmDatVersion")
    
    @schemas.classproperty
    def COMPUTER_AM_DAT_DATE(cls):
        return cls("computerAmDatDate")
    
    @schemas.classproperty
    def COMPUTER_AM_DAT_DATE_FROM(cls):
        return cls("computerAmDatDateFrom")
    
    @schemas.classproperty
    def COMPUTER_AM_DAT_DATE_TO(cls):
        return cls("computerAmDatDateTo")
    
    @schemas.classproperty
    def COMPUTER_AM_LIC_EXPIRATION_DATE(cls):
        return cls("computerAmLicExpirationDate")
    
    @schemas.classproperty
    def COMPUTER_AM_PROVIDER_BRAND_REPORT(cls):
        return cls("computerAmProviderBrandReport")
    
    @schemas.classproperty
    def COMPUTER_AM_LIC_EXPIRATION_DATE_FROM(cls):
        return cls("computerAmLicExpirationDateFrom")
    
    @schemas.classproperty
    def COMPUTER_AM_LIC_EXPIRATION_DATE_TO(cls):
        return cls("computerAmLicExpirationDateTo")
    
    @schemas.classproperty
    def COMPUTER_AM_TOTAL_INFECTED(cls):
        return cls("computerAmTotalInfected")
    
    @schemas.classproperty
    def COMPUTER_AM_TOTAL_INFECTED_FROM(cls):
        return cls("computerAmTotalInfectedFrom")
    
    @schemas.classproperty
    def COMPUTER_AM_TOTAL_INFECTED_TO(cls):
        return cls("computerAmTotalInfectedTo")
    
    @schemas.classproperty
    def COMPUTER_AM_INFECTIONS(cls):
        return cls("computerAmInfections")
    
    @schemas.classproperty
    def COMPUTER_SD_PACKAGE_NAME(cls):
        return cls("computerSdPackageName")
    
    @schemas.classproperty
    def COMPUTER_SD_POLICY_NAME(cls):
        return cls("computerSdPolicyName")
    
    @schemas.classproperty
    def COMPUTER_SD_POLICY_VERSION(cls):
        return cls("computerSdPolicyVersion")
    
    @schemas.classproperty
    def COMPUTER_AB_STATE(cls):
        return cls("computerAbState")
    
    @schemas.classproperty
    def COMPUTER_AB_STATUS_BOT_NAMES(cls):
        return cls("computerAbStatusBotNames")
    
    @schemas.classproperty
    def COMPUTER_AM_SCANNEDON(cls):
        return cls("computerAmScannedon")
    
    @schemas.classproperty
    def COMPUTER_AM_SCANNEDON_FROM(cls):
        return cls("computerAmScannedonFrom")
    
    @schemas.classproperty
    def COMPUTER_AM_SCANNEDON_TO(cls):
        return cls("computerAmScannedonTo")
    
    @schemas.classproperty
    def COMPUTER_AM_TOTAL_QUARANTINED(cls):
        return cls("computerAmTotalQuarantined")
    
    @schemas.classproperty
    def COMPUTER_AM_TOTAL_QUARANTINED_FROM(cls):
        return cls("computerAmTotalQuarantinedFrom")
    
    @schemas.classproperty
    def COMPUTER_AM_TOTAL_QUARANTINED_TO(cls):
        return cls("computerAmTotalQuarantinedTo")
    
    @schemas.classproperty
    def COMPUTER_LAST_CONTACTED_POLICY_SERVER_IP(cls):
        return cls("computerLastContactedPolicyServerIp")
    
    @schemas.classproperty
    def COMPUTER_LAST_CONTACTED_POLICY_SERVER_NAME(cls):
        return cls("computerLastContactedPolicyServerName")
    
    @schemas.classproperty
    def COMPUTER_SD_PACKAGE_VERSION(cls):
        return cls("computerSdPackageVersion")
    
    @schemas.classproperty
    def COMPUTER_COMPLIANCE_VIOLATION_IDS(cls):
        return cls("computerComplianceViolationIds")
    
    @schemas.classproperty
    def COMPUTER_SMART_CARD_STATUS(cls):
        return cls("computerSmartCardStatus")
    
    @schemas.classproperty
    def FDE_REMOTE_UNLOCK_OPERATION(cls):
        return cls("fdeRemoteUnlockOperation")
    
    @schemas.classproperty
    def FDE_REMOTE_UNLOCK_STATUS(cls):
        return cls("fdeRemoteUnlockStatus")
    
    @schemas.classproperty
    def COMPUTER_CANONICAL_NAME(cls):
        return cls("computerCanonicalName")
    
    @schemas.classproperty
    def STOPPED_BLADES(cls):
        return cls("stoppedBlades")
    
    @schemas.classproperty
    def ENFORCED_MODIFIED_ON(cls):
        return cls("enforcedModifiedOn")
    
    @schemas.classproperty
    def ENFORCED_POLICY_MALWARE20(cls):
        return cls("enforcedPolicyMalware20")
    
    @schemas.classproperty
    def ENFORCED_POLICY_TE130(cls):
        return cls("enforcedPolicyTe130")
    
    @schemas.classproperty
    def ENFORCED_POLICY_EFR120(cls):
        return cls("enforcedPolicyEfr120")
    
    @schemas.classproperty
    def ENFORCED_POLICY_ANTIBOT100(cls):
        return cls("enforcedPolicyAntibot100")
    
    @schemas.classproperty
    def ENFORCED_POLICY_ME30(cls):
        return cls("enforcedPolicyMe30")
    
    @schemas.classproperty
    def ENFORCED_POLICY_FDE_DEVICE35(cls):
        return cls("enforcedPolicyFdeDevice35")
    
    @schemas.classproperty
    def ENFORCED_POLICY_FDE_USER36(cls):
        return cls("enforcedPolicyFdeUser36")
    
    @schemas.classproperty
    def ENFORCED_POLICY_FW10(cls):
        return cls("enforcedPolicyFw10")
    
    @schemas.classproperty
    def ENFORCED_POLICY_COMPLIANCE60(cls):
        return cls("enforcedPolicyCompliance60")
    
    @schemas.classproperty
    def ENFORCED_POLICY_APPLICATION_CONTROL22(cls):
        return cls("enforcedPolicyApplicationControl22")
    
    @schemas.classproperty
    def ENFORCED_POLICY_SA_ACCESS_ZONES11(cls):
        return cls("enforcedPolicySaAccessZones11")
    
    @schemas.classproperty
    def ENFORCED_POLICY_COMMON_CLIENT_SETTINGS51(cls):
        return cls("enforcedPolicyCommonClientSettings51")
    
    @schemas.classproperty
    def ENFORCED_POLICY_DOC_SEC_POLICY91(cls):
        return cls("enforcedPolicyDocSecPolicy91")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_MALWARE20(cls):
        return cls("enforcedVersionPolicyMalware20")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_TE130(cls):
        return cls("enforcedVersionPolicyTe130")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_EFR120(cls):
        return cls("enforcedVersionPolicyEfr120")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_ANTIBOT100(cls):
        return cls("enforcedVersionPolicyAntibot100")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_ME30(cls):
        return cls("enforcedVersionPolicyMe30")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_FDE_DEVICE35(cls):
        return cls("enforcedVersionPolicyFdeDevice35")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_FDE_USER36(cls):
        return cls("enforcedVersionPolicyFdeUser36")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_FW10(cls):
        return cls("enforcedVersionPolicyFw10")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_COMPLIANCE60(cls):
        return cls("enforcedVersionPolicyCompliance60")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_APPLICATION_CONTROL22(cls):
        return cls("enforcedVersionPolicyApplicationControl22")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_SA_ACCESS_ZONES11(cls):
        return cls("enforcedVersionPolicySaAccessZones11")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_COMMON_CLIENT_SETTINGS51(cls):
        return cls("enforcedVersionPolicyCommonClientSettings51")
    
    @schemas.classproperty
    def ENFORCED_VERSION_POLICY_DOC_SEC_POLICY91(cls):
        return cls("enforcedVersionPolicyDocSecPolicy91")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_MALWARE20(cls):
        return cls("enforcedNamePolicyMalware20")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_TE130(cls):
        return cls("enforcedNamePolicyTe130")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_EFR120(cls):
        return cls("enforcedNamePolicyEfr120")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_ANTIBOT100(cls):
        return cls("enforcedNamePolicyAntibot100")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_ME30(cls):
        return cls("enforcedNamePolicyMe30")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_FDE_DEVICE35(cls):
        return cls("enforcedNamePolicyFdeDevice35")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_FDE_USER36(cls):
        return cls("enforcedNamePolicyFdeUser36")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_FW10(cls):
        return cls("enforcedNamePolicyFw10")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_COMPLIANCE60(cls):
        return cls("enforcedNamePolicyCompliance60")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_APPLICATION_CONTROL22(cls):
        return cls("enforcedNamePolicyApplicationControl22")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_SA_ACCESS_ZONES11(cls):
        return cls("enforcedNamePolicySaAccessZones11")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_COMMON_CLIENT_SETTINGS51(cls):
        return cls("enforcedNamePolicyCommonClientSettings51")
    
    @schemas.classproperty
    def ENFORCED_NAME_POLICY_DOC_SEC_POLICY91(cls):
        return cls("enforcedNamePolicyDocSecPolicy91")
    
    @schemas.classproperty
    def DEPLOYED_MODIFIED_ON(cls):
        return cls("deployedModifiedOn")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_MALWARE20(cls):
        return cls("deployedPolicyMalware20")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_TE130(cls):
        return cls("deployedPolicyTe130")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_EFR120(cls):
        return cls("deployedPolicyEfr120")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_ANTIBOT100(cls):
        return cls("deployedPolicyAntibot100")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_ME30(cls):
        return cls("deployedPolicyMe30")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_FDE_DEVICE35(cls):
        return cls("deployedPolicyFdeDevice35")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_FDE_USER36(cls):
        return cls("deployedPolicyFdeUser36")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_FW10(cls):
        return cls("deployedPolicyFw10")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_COMPLIANCE60(cls):
        return cls("deployedPolicyCompliance60")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_APPLICATION_CONTROL22(cls):
        return cls("deployedPolicyApplicationControl22")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_SA_ACCESS_ZONES11(cls):
        return cls("deployedPolicySaAccessZones11")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_COMMON_CLIENT_SETTINGS51(cls):
        return cls("deployedPolicyCommonClientSettings51")
    
    @schemas.classproperty
    def DEPLOYED_POLICY_DOC_SEC_POLICY91(cls):
        return cls("deployedPolicyDocSecPolicy91")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_MALWARE20(cls):
        return cls("deployedVersionPolicyMalware20")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_TE130(cls):
        return cls("deployedVersionPolicyTe130")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_EFR120(cls):
        return cls("deployedVersionPolicyEfr120")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_ANTIBOT100(cls):
        return cls("deployedVersionPolicyAntibot100")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_ME30(cls):
        return cls("deployedVersionPolicyMe30")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_FDE_DEVICE35(cls):
        return cls("deployedVersionPolicyFdeDevice35")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_FDE_USER36(cls):
        return cls("deployedVersionPolicyFdeUser36")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_FW10(cls):
        return cls("deployedVersionPolicyFw10")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_COMPLIANCE60(cls):
        return cls("deployedVersionPolicyCompliance60")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_APPLICATION_CONTROL22(cls):
        return cls("deployedVersionPolicyApplicationControl22")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_SA_ACCESS_ZONES11(cls):
        return cls("deployedVersionPolicySaAccessZones11")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_COMMON_CLIENT_SETTINGS51(cls):
        return cls("deployedVersionPolicyCommonClientSettings51")
    
    @schemas.classproperty
    def DEPLOYED_VERSION_POLICY_DOC_SEC_POLICY91(cls):
        return cls("deployedVersionPolicyDocSecPolicy91")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_MALWARE20(cls):
        return cls("deployedNamePolicyMalware20")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_TE130(cls):
        return cls("deployedNamePolicyTe130")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_EFR120(cls):
        return cls("deployedNamePolicyEfr120")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_ANTIBOT100(cls):
        return cls("deployedNamePolicyAntibot100")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_ME30(cls):
        return cls("deployedNamePolicyMe30")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_FDE_DEVICE35(cls):
        return cls("deployedNamePolicyFdeDevice35")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_FDE_USER36(cls):
        return cls("deployedNamePolicyFdeUser36")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_FW10(cls):
        return cls("deployedNamePolicyFw10")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_COMPLIANCE60(cls):
        return cls("deployedNamePolicyCompliance60")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_APPLICATION_CONTROL22(cls):
        return cls("deployedNamePolicyApplicationControl22")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_SA_ACCESS_ZONES11(cls):
        return cls("deployedNamePolicySaAccessZones11")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_COMMON_CLIENT_SETTINGS51(cls):
        return cls("deployedNamePolicyCommonClientSettings51")
    
    @schemas.classproperty
    def DEPLOYED_NAME_POLICY_DOC_SEC_POLICY91(cls):
        return cls("deployedNamePolicyDocSecPolicy91")
    
    @schemas.classproperty
    def COMPUTER_CPU_LOAD_CATEGORY(cls):
        return cls("computerCpuLoadCategory")
    
    @schemas.classproperty
    def COMPUTER_TOTAL_CPU_LOAD_CATEGORY(cls):
        return cls("computerTotalCpuLoadCategory")
    
    @schemas.classproperty
    def COMPUTER_CPU_RANK(cls):
        return cls("computerCpuRank")
    
    @schemas.classproperty
    def COMPUTER_TOTAL_CPU_RANK(cls):
        return cls("computerTotalCpuRank")
    
    @schemas.classproperty
    def DEVICE_COMMENT(cls):
        return cls("deviceComment")
    
    @schemas.classproperty
    def COMPUTER_GROUPS(cls):
        return cls("computerGroups")
    
    @schemas.classproperty
    def COMPUTER_OR_USERS(cls):
        return cls("computerOrUsers")
    
    @schemas.classproperty
    def FILTER_AND_THOSE_COMPUTERS(cls):
        return cls("filterAndThoseComputers")
    
    @schemas.classproperty
    def FILTER_AND_THOSE_COMPUTERS_OR_USERS(cls):
        return cls("filterAndThoseComputersOrUsers")
    
    @schemas.classproperty
    def FILTER_COMPLIANCE_STATUS(cls):
        return cls("filterComplianceStatus")
    
    @schemas.classproperty
    def COMPUTER_FREE_SEARCH(cls):
        return cls("computerFreeSearch")
    
    @schemas.classproperty
    def COMPUTER_ENFORCED_INSTALLED_POLICY_NAME(cls):
        return cls("computerEnforcedInstalledPolicyName")
    
    @schemas.classproperty
    def COMPUTER_ENFORCED_INSTALLED_POLICY_VERSION(cls):
        return cls("computerEnforcedInstalledPolicyVersion")
    
    @schemas.classproperty
    def COMPUTER_STOPPED_BLADES(cls):
        return cls("computerStoppedBlades")
    
    @schemas.classproperty
    def IS_DEVICE_IN_GROUP(cls):
        return cls("Is_Device_In_Group")
    
    @schemas.classproperty
    def GLOBAL(cls):
        return cls("global")
    
    @schemas.classproperty
    def PERMISSION(cls):
        return cls("permission")
