# coding: utf-8

"""
    Harmony Endpoint Management (Cloud API)

    <p>Harmony Endpoint offers a new web management interface for cloud users. By using the api, you will setup a virtual Endpoint management service in the cloud to manage policies and deployments for Harmony Endpoint agents.</p><p>The following documentation provides the operations supported by the Harmony Endpoint's Cloud API.</p><p>To use the Harmony Endpoint Cloud API service:</p><ol><li><p>Login as user to infinity portal, Using the Authenticate API .</p></li><li><p>Authenticate using the&nbsp;<a href='https://app.swaggerhub.com/apis-docs/Check-Point/infinity-portal-api/1.0.1#/Authentication/post_auth_userl' rel='noopener noreferrer'>Infinity Portal Authentication Service</a>, making sure to select the correct Infinity Portal API Server for the geographic region of your tenant.</p></li><li><p>Include the resulting <em>csrf </em>in the <em>'x-access-token' </em>header and the 'cloudinfra' cookie in every request made to the API service.</p></li><li><p>Call the Mssp Login API</p></li><li>Include return token in 'x-mgmt-mssp-session'&nbsp;in every request made to the API service.</li></ol><p><strong>* notice mssp session will expired after 5min you can use the keep-alive api to extend it.</strong></p><p>&nbsp;</p><p><strong>please use base path for the api's according to your tenant region:</strong></p><table style='height: 108px; width: 100%; border-collapse: collapse;' border='1'><tbody><tr style='height: 18px;'><td style='width: 50%; height: 18px; background: #4795d9'><strong>Region</strong></td><td style='width: 50%; height: 18px; background: #4795d9'><strong>Base Path</strong></td></tr><tr style='height: 18px;'><td style='width: 50%; height: 18px;'>EU</td><td style='width: 50%; height: 18px;'>https://cloudinfra-gw.portal.checkpoint.com</td></tr><tr style='height: 18px;'><td style='width: 50%; height: 18px;'>US</td><td style='width: 50%; height: 18px;'>https://cloudinfra-gw-us.portal.checkpoint.com</td></tr><tr style='height: 18px;'><td style='width: 50%; height: 18px;'>AP</td><td style='width: 50%; height: 18px;'>https://cloudinfra-gw.ap.portal.checkpoint.com</td></tr><tr style='height: 18px;'><td style='width: 50%; height: 18px;'>IN</td><td style='width: 50%; height: 18px;'>https://cloudinfra-gw.in.portal.checkpoint.com</td></tr><tr style='height: 18px;'><td style='width: 50%; height: 18px;'>UK</td><td style='width: 50%; height: 18px;'>https://cloudinfra-gw.uk.portal.checkpoint.com</td></tr></tbody></table><br><br>  # noqa: E501

    The version of the OpenAPI document: 1.0.626
    Contact: harmony-endpoint-external-api@checkpoint.com
    Generated by: https://openapi-generator.tech
"""

from chkp_harmony_endpoint_management_sdk.generated.saas.paths.public_mssp_v1_session_keep_alive.post import PublicMsspKeepAlive
from chkp_harmony_endpoint_management_sdk.generated.saas.paths.public_mssp_v1_session_login.post import PublicMsspLogin


class ManageSessionApi(
    PublicMsspKeepAlive,
    PublicMsspLogin,
):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    pass
